import { __awaiter } from "tslib";
import { GapMiniAppSdk, Platform } from "gap-miniapp-sdk";
import { CloverUsbPaymentResponseModel } from "./clover-usb-payment-response-model";
import { jsonrepair } from "jsonrepair";
export class CloverUsbPaymentClient {
    initializePaymentClient(_client) {
        //Example for paymentClientConfiguration:
        // this.paymentClientConfiguration = {
        //     driver: GapPaymentClientDriver.PAX,
        //     configuration: {
        //         platform: "Window",
        //         ip: "192.168.1.1",
        //         port: "9000"
        //     }
        // }
        if (_client instanceof GapMiniAppSdk) {
            this.paymentClient = _client;
        }
        else {
            this.paymentClient = new GapMiniAppSdk();
            this.paymentClient.setPlatformExecutor(Platform.WINDOW);
        }
        this.paymentClient.paymentRequest({ "type": "connect" });
    }
    ;
    doAuth(paymentInput) {
        return new Promise((resolve, reject) => __awaiter(this, void 0, void 0, function* () {
            try {
                let data = yield this.paymentClient.paymentRequest(Object.assign({ type: 'do_payment' }, paymentInput));
                if (data != null && data.dataType && data.dataType == 'base64') {
                    data = atob(data.data);
                }
                let jsonData = this.tryParseJson(data);
                if (typeof jsonData === 'string') {
                    jsonData = { "data": jsonData };
                }
                let paymentResponse = CloverUsbPaymentResponseModel.build(Object.assign(Object.assign({}, jsonData), { 'type': 'auth' }));
                ;
                resolve(paymentResponse);
            }
            catch (e) {
                reject(e);
            }
        }));
    }
    ;
    doSale(paymentInput) {
        return new Promise((resolve, reject) => __awaiter(this, void 0, void 0, function* () {
            try {
                let data = yield this.paymentClient.paymentRequest(Object.assign({ type: 'do_payment' }, paymentInput));
                if (data != null && data.dataType && data.dataType == 'base64') {
                    data = atob(data.data);
                }
                let jsonData = this.tryParseJson(data);
                if (typeof jsonData === 'string') {
                    jsonData = { "data": jsonData };
                }
                let paymentResponse = CloverUsbPaymentResponseModel.build(Object.assign(Object.assign({}, jsonData), { 'type': 'sale' }));
                ;
                resolve(paymentResponse);
            }
            catch (e) {
                reject(e);
            }
        }));
    }
    ;
    doAdjust(adjustInput) {
        return new Promise((resolve, reject) => __awaiter(this, void 0, void 0, function* () {
            try {
                let data = yield this.paymentClient.paymentRequest(Object.assign({ type: 'do_adjust' }, adjustInput));
                if (data != null && data.dataType && data.dataType == 'base64') {
                    data = atob(data.data);
                }
                let jsonData = this.tryParseJson(data);
                if (typeof jsonData === 'string') {
                    jsonData = { "data": jsonData };
                }
                let paymentResponse = CloverUsbPaymentResponseModel.build(Object.assign(Object.assign({}, jsonData), { 'type': 'adjust' }));
                ;
                resolve(paymentResponse);
            }
            catch (e) {
                reject(e);
            }
        }));
    }
    ;
    doVoid(voidInput) {
        return new Promise((resolve, reject) => __awaiter(this, void 0, void 0, function* () {
            try {
                let data = yield this.paymentClient.paymentRequest(Object.assign({ type: 'do_void' }, voidInput));
                if (data != null && data.dataType && data.dataType == 'base64') {
                    data = atob(data.data);
                }
                let jsonData = this.tryParseJson(data);
                if (typeof jsonData === 'string') {
                    jsonData = { "data": jsonData };
                }
                let paymentResponse = CloverUsbPaymentResponseModel.build(Object.assign(Object.assign({}, jsonData), { 'type': 'void' }));
                ;
                resolve(paymentResponse);
            }
            catch (e) {
                reject(e);
            }
        }));
    }
    ;
    doRefund(refundInput) {
        return new Promise((resolve, reject) => __awaiter(this, void 0, void 0, function* () {
            try {
                let data = yield this.paymentClient.paymentRequest(Object.assign({ type: 'do_refund' }, refundInput));
                if (data != null && data.dataType && data.dataType == 'base64') {
                    data = atob(data.data);
                }
                let jsonData = this.tryParseJson(data);
                if (typeof jsonData === 'string') {
                    jsonData = { "data": jsonData };
                }
                let paymentResponse = CloverUsbPaymentResponseModel.build(Object.assign(Object.assign({}, jsonData), { 'type': 'refund' }));
                ;
                resolve(paymentResponse);
            }
            catch (e) {
                reject(e);
            }
        }));
    }
    ;
    doBatchClose() {
        return new Promise((resolve, reject) => __awaiter(this, void 0, void 0, function* () {
            try {
                let data = yield this.paymentClient.paymentRequest({ type: 'do_batch_close' });
                let jsonData = this.tryParseJson(data);
                if (typeof jsonData === 'string') {
                    jsonData = { "data": jsonData };
                }
                let paymentResponse = CloverUsbPaymentResponseModel.build(Object.assign(Object.assign({}, jsonData), { 'type': 'batch_close' }));
                ;
                resolve(paymentResponse);
            }
            catch (e) {
                reject(e);
            }
        }));
    }
    ;
    doRetrieve(retrieveInput) {
        return new Promise((resolve, reject) => __awaiter(this, void 0, void 0, function* () {
            try {
                let data = yield this.paymentClient.paymentRequest(Object.assign({ type: 'do_retrieve' }, retrieveInput));
                if (data != null && data.dataType && data.dataType == 'base64') {
                    data = atob(data.data);
                }
                let jsonData = this.tryParseJson(data);
                if (typeof jsonData === 'string') {
                    jsonData = { "data": jsonData };
                }
                let paymentResponse = CloverUsbPaymentResponseModel.build(Object.assign(Object.assign({}, jsonData), { 'type': 'retrieve' }));
                ;
                resolve(paymentResponse);
            }
            catch (e) {
                reject(e);
            }
        }));
    }
    ;
    cancel() {
        return new Promise((resolve, reject) => __awaiter(this, void 0, void 0, function* () {
            try {
                yield this.paymentClient.paymentRequest({ type: 'do_cancel' });
                resolve(true);
            }
            catch (e) {
                reject(false);
            }
        }));
    }
    ;
    dispose() {
        return new Promise((resolve, reject) => __awaiter(this, void 0, void 0, function* () {
            try {
                yield this.paymentClient.paymentRequest({ type: 'disconnect' });
                resolve();
            }
            catch (e) {
                reject(e);
            }
        }));
    }
    ;
    doShowDisplayOrder(order) {
        this.paymentClient.paymentRequest({ type: 'show_display_order', order });
        console.log(order);
    }
    ;
    doRemoveDisplayOrder(_order) {
        this.paymentClient.paymentRequest({ type: 'show_welcome_screen' });
    }
    ;
    getDeviceStatus() {
        return new Promise((resolve) => __awaiter(this, void 0, void 0, function* () {
            try {
                let data = yield this.paymentClient.paymentRequest({ type: 'get_status' });
                resolve(data);
            }
            catch (e) {
                resolve({ "deviceConnected": false, "deviceReady": false });
            }
        }));
    }
    ;
    showMessage(message) {
        this.paymentClient.paymentRequest({ type: 'show_message', message });
    }
    ;
    showWelcomeScreen() {
        this.paymentClient.paymentRequest({ type: 'show_welcome_screen' });
    }
    ;
    showThankYouScreen() {
        this.paymentClient.paymentRequest({ type: 'show_thank_you_screen' });
    }
    ;
    doPrint(printRequest) {
        this.paymentClient.paymentRequest({ type: 'do_print', printRequest });
    }
    ;
    openCashDrawer() {
        this.paymentClient.paymentRequest({ type: 'open_cash_drawer' });
    }
    ;
    deviceInfo() {
        return new Promise((resolve, reject) => __awaiter(this, void 0, void 0, function* () {
            try {
                let data = yield this.paymentClient.paymentRequest({ type: 'do_device_info' });
                resolve(data);
            }
            catch (e) {
                reject(e);
            }
        }));
    }
    ;
    tryParseJson(str) {
        try {
            str = jsonrepair(str);
            let jsonData = JSON.parse(str);
            return jsonData;
        }
        catch (e) {
            return str;
        }
    }
}
